<?php

namespace app\controllers\mikrotik\mpls\vpls;

use yii\helpers\Url;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use app\models\mikrotik\bridge\Bridge;
use app\models\mikrotik\MikrotikSideMenu;
use app\models\mikrotik\mpls\vpls\Cisco;

class CiscoController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                  [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_vplsCreateCisco'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_vplsDeleteCisco'],
                    ],
                    [
                        'actions' => ['disable'],
                        'allow' => true,
                        'roles' => ['mikrotik_vplsDisableCisco'],
                    ],
                    [
                        'actions' => ['enable'],
                        'allow' => true,
                        'roles' => ['mikrotik_vplsEnableCisco'],
                    ],
                     [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_vplsUpdateCisco'],
                    ],
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionIndex() {
        $cisco = new Cisco();
        return var_dump($cisco->getAll());
    }

    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $menu = new MikrotikSideMenu();
        $model = new Cisco();
        $bridge = new Bridge();
        $brn = $bridge->getNames();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $c = $model->update($id);
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/mpls/vpls/vpls/index'));
            }
        } else {
            $model->get($id);
        }

        return $this->render('/mikrotik/mpls/vpls/cisco', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'update',
                    'bridge' => $brn,
        ]);
    }

    public function actionCreate() {
        $menu = new MikrotikSideMenu();
        $model = new Cisco();
        $bridge = new Bridge();
        $brn = $bridge->getNames();
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {
            $c = $model->create();
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/mpls/vpls/vpls/index'));
            }
        }

        return $this->render('/mikrotik/mpls/vpls/cisco', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'create',
                    'bridge' => $brn,
        ]);
    }

    public function actionDisable() {
        $id = Yii::$app->request->get('id');
        $model = new Cisco();
        $model->disable($id);
        return $this->redirect(Url::toRoute('mikrotik/mpls/vpls/vpls/index'));
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Cisco();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/mpls/vpls/vpls/index'));
    }

    public function actionEnable() {
        $id = Yii::$app->request->get('id');
        $model = new Cisco();
        $model->enable($id);
        return $this->redirect(Url::toRoute('mikrotik/mpls/vpls/vpls/index'));
    }

}
